unit CrowdEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin, ExtCtrls;

type
  TCrowdEditForm = class(TForm)
    ParamEditPanel: TPanel;
    Image1: TImage;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit6: TSpinEdit;
    SpinEdit7: TSpinEdit;
    SpinEdit8: TSpinEdit;
    SpinEdit9: TSpinEdit;
    SpinEdit10: TSpinEdit;
    SpinEdit11: TSpinEdit;
    SpinEdit12: TSpinEdit;
    SpinEdit13: TSpinEdit;
    SpinEdit14: TSpinEdit;
    SpinEdit15: TSpinEdit;
    SpinEdit16: TSpinEdit;
    SeekEd: TEdit;
    ActEdit: TEdit;
    ActInact: TUpDown;
    CopyExec: TButton;
    CopyPanel: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    EndCopy: TSpinEdit;
    StartCopy: TSpinEdit;
    SetRandom: TCheckBox;
    SeqPers: TCheckBox;
    SetPersonNum: TSpinEdit;
    SpinEdit17: TSpinEdit;
    SpinEdit18: TSpinEdit;
    SeekUpDown: TUpDown;
    ClearAll: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    CheckBox17: TCheckBox;
    CheckBox18: TCheckBox;
    SetAll: TButton;
    SetNone: TButton;
    CheckBox19: TCheckBox;
    CheckBox20: TCheckBox;
    Memo1: TMemo;
    ParamExitBtn: TButton;
    procedure FormShow(Sender: TObject);
    procedure SetPersonNumChange(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit6Change(Sender: TObject);
    procedure SpinEdit7Change(Sender: TObject);
    procedure SpinEdit8Change(Sender: TObject);
    procedure SpinEdit9Change(Sender: TObject);
    procedure SpinEdit10Change(Sender: TObject);
    procedure SpinEdit11Change(Sender: TObject);
    procedure SpinEdit12Change(Sender: TObject);
    procedure SpinEdit13Change(Sender: TObject);
    procedure SpinEdit14Change(Sender: TObject);
    procedure SpinEdit15Change(Sender: TObject);
    procedure SpinEdit16Change(Sender: TObject);
    procedure SpinEdit17Change(Sender: TObject);
    procedure SpinEdit18Change(Sender: TObject);
    procedure SeekUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure ActInactClick(Sender: TObject; Button: TUDBtnType);
    procedure SetNoneClick(Sender: TObject);
    procedure SetAllClick(Sender: TObject);
    procedure ClearAllClick(Sender: TObject);
    procedure CopyExecClick(Sender: TObject);
    procedure StartCopyChange(Sender: TObject);
    procedure EndCopyChange(Sender: TObject);
    procedure SetRandomClick(Sender: TObject);
    procedure ParamExitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ShowLegends;
    procedure ShowParams(Person: Integer);
    procedure ExecuteCopy;
  end;

var
  CrowdEditForm: TCrowdEditForm;

implementation

uses Main;

{$R *.dfm}

procedure TCrowdEditForm.ShowLegends;
var
  I: Integer;
begin
  with Image1.Canvas do
  begin
    Font.Name := 'Courier New';
    Font.Size := 10;
    for I := 0 to 17 do
      TextOut(1, 2+Round(24.0*I), ParamLegends[I]);
  end;
end;

function EditNumOK(S: string): Boolean;
var
  T, Code: Integer;
begin
  Val(S, T, Code);
  EditNumOK := Code = 0;
end;

procedure TCrowdEditForm.ExecuteCopy;
var
  I: integer;
begin
  if (FirstCopyNum <= LastCopyNum) and (LastCopyNum <= MaxObjects - 1) then
    for I := FirstCopyNum to LastCopyNum do
      with PP[Person] do
      begin
        if RandomPos then
        begin
          PP[I].InitX := InitX + Random(200) - 100;
          PP[I].InitY := InitY + Random(200) - 100;
        end
        else
        begin
          if CheckBox1.Checked then PP[I].InitX := InitX;
          if CheckBox2.Checked then PP[I].InitY := InitY;
        end;
        if CheckBox3.Checked then PP[I].InitDir := InitDir;;
        if CheckBox6.Checked then PP[I].AvoidProx.r := AvoidProx.r;
        if CheckBox7.Checked then PP[I].AvoidProx.g := AvoidProx.g;
        if CheckBox8.Checked then PP[I].SeekProx.r := SeekProx.r;
        if CheckBox9.Checked then PP[I].SeekProx.g := SeekProx.g;
        if CheckBox10.Checked then PP[I].SeekDir.r := SeekDir.r;
        if CheckBox11.Checked then PP[I].SeekDir.g := SeekDir.g;
        if CheckBox12.Checked then PP[I].DestProx.r := DestProx.r;
        if CheckBox13.Checked then PP[I].DestProx.g := DestProx.g;
        if CheckBox14.Checked then PP[I].DestDir.r := DestDir.r;
        if CheckBox15.Checked then PP[I].DestDir.g:= DestDir.g;
        if CheckBox16.Checked then PP[I].SeekPD := SeekPD;
        if (SeqPers.Checked) and (PP[I].SeekPD = 2)
          then PP[I].SeekPerNum := i - 1
        else
          if CheckBox17.Checked then
            PP[I].SeekPerNum := SeekPerNum;
        if CheckBox18.Checked then PP[I].Status :=  Status;
        if CheckBox19.Checked then PP[I].DestX := DestX;
        if CheckBox20.Checked then PP[I].DestY := DestY;
      end;
end;


procedure TCrowdEditForm.ShowParams(Person: Integer);
begin
  with PP[Person] do
  begin
    SpinEdit1.value := Round(InitX);
    SpinEdit2.value := Round(InitY);
    SpinEdit3.value := Round(180/pi*InitDir);
    SpinEdit6.value := Round(AvoidProx.r);
    SpinEdit7.value := Round(AvoidProx.g);
    SpinEdit8.value := Round(SeekProx.r);
    SpinEdit9.value := Round(SeekProx.g);
    SpinEdit10.value := Round(180/pi*SeekDir.r);
    SpinEdit11.value := Round(SeekDir.g);
    SpinEdit12.value := Round(DestProx.r);
    SpinEdit13.value := Round(DestProx.g);
    SpinEdit14.value := Round(180/pi*DestDir.r);
    SpinEdit15.value := Round(DestDir.g);
    SpinEdit16.value := SeekPerNum;
    SpinEdit17.value := Round(DestX);
    SpinEdit18.value := Round(DestY);
    case SeekPD of
      0: SeekEd.Text := 'None';
      1: SeekEd.Text := 'Dest''n';
      2: SeekEd.Text := 'Person';
      end;
    SeekUpDown.Position := SeekPD;
    case Status of
      -1: Actedit.Text := 'Unused';
       0: Actedit.Text := 'Inactive';    // rsandomly placed
       1: Actedit.Text := 'Active';
       2: Actedit.Text := 'Fixed';       // remain in same place
       end;
    ActInact.Position := Status + 1;
  end;
end;

procedure TCrowdEditForm.FormShow(Sender: TObject);
begin
  ShowParams(Person);
  ShowLegends;
  Memo1.Lines.LoadFromFile('Editing.txt');
end;

procedure TCrowdEditForm.SetPersonNumChange(Sender: TObject);
begin
  if not EditNumOK(SetPersonNum.Text) then Exit;
  Person := SetPersonNum.Value;
  ShowParams(Person);
end;

procedure TCrowdEditForm.SpinEdit1Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit1.Text) then Exit;
  PP[Person].InitX := SpinEdit1.Value;
end;

procedure TCrowdEditForm.SpinEdit2Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit2.Text) then Exit;
  with PP[Person] do
    InitY := SpinEdit2.Value;
end;

procedure TCrowdEditForm.SpinEdit3Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit3.Text) then Exit;
  with PP[Person] do
    InitDir := pi/180.0*SpinEdit3.Value;
end ;

procedure TCrowdEditForm.SpinEdit6Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit6.Text) then Exit;
  with PP[Person] do
    AvoidProx.r := SpinEdit6.Value;
end;

procedure TCrowdEditForm.SpinEdit7Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit7.Text) then Exit;
   with PP[Person] do
     AvoidProx.g := SpinEdit7.Value;
end;

procedure TCrowdEditForm.SpinEdit8Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit8.Text) then Exit;
  with PP[Person] do
    SeekProx.r := SpinEdit8.Value;
end;

procedure TCrowdEditForm.SpinEdit9Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit9.Text) then Exit;
  with PP[Person] do
    SeekProx.g := SpinEdit9.Value;
end;

procedure TCrowdEditForm.SpinEdit10Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit10.Text) then Exit;
  with PP[Person] do
    SeekDir.r := pi/180.0*SpinEdit10.Value;
end;

procedure TCrowdEditForm.SpinEdit11Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit11.Text) then Exit;
  with PP[Person] do
    SeekDir.g := SpinEdit11.Value;
end;

procedure TCrowdEditForm.SpinEdit12Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit12.Text) then Exit;
  with PP[Person] do
    DestProx.r := SpinEdit12.Value;
end;

procedure TCrowdEditForm.SpinEdit13Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit13.Text) then Exit;
  with PP[Person] do
    DestProx.g := SpinEdit13.Value;
end;

procedure TCrowdEditForm.SpinEdit14Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit14.Text) then Exit;
  with PP[Person] do
    DestDir.r := pi/180.0*SpinEdit14.Value;
end;

procedure TCrowdEditForm.SpinEdit15Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit15.Text) then Exit;
  with PP[Person] do
    DestDir.g := SpinEdit15.Value;
end;

procedure TCrowdEditForm.SpinEdit16Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit16.Text) then Exit;
  with PP[Person] do
    SeekPerNum := SpinEdit16.Value;
end;

procedure TCrowdEditForm.SpinEdit17Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit17.Text) then Exit;
  PP[Person].DestX := SpinEdit17.Value;
end;

procedure TCrowdEditForm.SpinEdit18Change(Sender: TObject);
begin
  if not EditNumOK(SpinEdit18.Text) then Exit;
  PP[person].DestY := SpinEdit18.Value;
end;

procedure TCrowdEditForm.SeekUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  case SeekUpDown.Position of
    0: begin
         SeekEd.Text := 'None';
         PP[Person].SeekPD := 0;
       end;
    1: begin
         SeekEd.Text := 'Dest''n';
         PP[Person].SeekPD := 1;
       end;
    2: begin
         SeekEd.Text := 'Person';
         PP[Person].SeekPD := 2;
       end;
    end;
end;

procedure TCrowdEditForm.ActInactClick(Sender: TObject;
  Button: TUDBtnType);
begin
  case ActInact.Position of
    0: begin
         Actedit.Text := 'Unused';
         PP[Person].Status := -1;
       end;
    1: begin
         Actedit.Text := 'Inactive';
         PP[Person].Status := 0;
       end;
    2: begin
         Actedit.Text := 'Active';
         PP[Person].Status := 1;
       end;
    3: begin
         Actedit.Text := 'Fixed';
         PP[Person].Status := 2;
       end;
    end;
end;

procedure TCrowdEditForm.SetNoneClick(Sender: TObject);
begin
  CheckBox1.Checked := False;
  CheckBox2.Checked := False;
  CheckBox3.Checked := False;
  CheckBox6.Checked := False;
  CheckBox7.Checked := False;
  CheckBox8.Checked := False;
  CheckBox9.Checked := False;
  CheckBox10.Checked := False;
  CheckBox11.Checked := False;
  CheckBox12.Checked := False;
  CheckBox13.Checked := False;
  CheckBox14.Checked := False;
  CheckBox15.Checked := False;
  CheckBox16.Checked := False;
  CheckBox17.Checked := False;
  CheckBox18.Checked := False;
  CheckBox19.Checked := False;
  CheckBox20.Checked := False;
end;

procedure TCrowdEditForm.SetAllClick(Sender: TObject);
begin
  CheckBox1.Checked := True;
  CheckBox2.Checked := True;
  CheckBox3.Checked := True;
  CheckBox6.Checked := True;
  CheckBox7.Checked := True;
  CheckBox8.Checked := True;
  CheckBox9.Checked := True;
  CheckBox10.Checked := True;
  CheckBox11.Checked := True;
  CheckBox12.Checked := True;
  CheckBox13.Checked := True;
  CheckBox14.Checked := True;
  CheckBox15.Checked := True;
  CheckBox16.Checked := True;
  CheckBox17.Checked := True;
  CheckBox18.Checked := True;
  CheckBox19.Checked := True;
  CheckBox20.Checked := True;
end;

procedure TCrowdEditForm.ClearAllClick(Sender: TObject);
var
  I: Integer;
begin
  for I := Person+1 to 255 do
  begin
    FillChar(PP[I],SizeOf(PP[I]),0);
    with PP[I] do
    begin
      Status := -1;
      SeekPD := 0;
     end;
  end;
  SetPersonNum.Value := Person;
  ShowParams(Person);
end;

procedure TCrowdEditForm.CopyExecClick(Sender: TObject);
begin
  CopyReady := not CopyReady;
  if Copyready then
    CopyExec.Caption := 'EXEC COPY';
  Copypanel.Visible := CopyReady;
  if Not CopyReady then
  begin
    ExecuteCopy;
    CopyExec.Caption := 'SET COPY';
  end;
end;

procedure TCrowdEditForm.StartCopyChange(Sender: TObject);
begin
  if not EditNumOK(StartCopy.Text) then Exit;
  FirstCopyNum := StartCopy.Value;
end;

procedure TCrowdEditForm.EndCopyChange(Sender: TObject);
begin
  if not EditNumOK(EndCopy.Text) then Exit;
  LastCopyNum := EndCopy.Value;
end;

procedure TCrowdEditForm.SetRandomClick(Sender: TObject);
begin
  RandomPos := SetRandom.Checked;
end;

procedure TCrowdEditForm.ParamExitBtnClick(Sender: TObject);
begin
  Close;
end;

end.
