unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    DemoSelect: TRadioGroup;
    ExecuteBtn: TButton;
    ExitBtn: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DemoSelectClick(Sender: TObject);
    procedure ExecuteBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses ShellAPI;

{$R *.dfm}

var
  Filename, Pathname, BaseDir: String;

 
procedure TMainForm.FormCreate(Sender: TObject);
begin
  BaseDir := GetCurrentDir;
  Pathname := '.\Demo2-1-ChooseControl\';
  Filename := 'ChooseControl.exe';
  DemoSelect.Left := MainForm.ClientWidth div 2 - DemoSelect.Width div 2;
  DemoSelect.Top := MainForm.ClientHeight div 2 - DemoSelect.Height div 2;
  ExecuteBtn.Left := DemoSelect.Left;
  ExecuteBtn.Top := DemoSelect.Top + DemoSelect.Height + 20;
  ExitBtn.Top := ExecuteBtn.Top;
  ExitBtn.Left := DemoSelect.Left + DemoSelect.Width - ExitBtn.Width;
end;

procedure TMainForm.DemoSelectClick(Sender: TObject);
begin
  Case DemoSelect.ItemIndex of
    0:  Filename := 'ChooseControl.exe';
    1:  Filename := 'LiveBlock.exe';
    2:  Filename := 'TrackAnalyze.exe';
    3:  Filename := 'NonAdaptive.exe';
    4:  Filename := 'LiveThree.exe';
    5:  Filename := 'Ecoli.exe';
    6:  Filename := 'ThreeSys.exe';
    7:  Filename := 'ArmControlReorg.exe';
    8:  Filename := 'Coordination.exe';
    9:  Filename := 'ArmTrackTarget.exe';
    10: Filename := 'SquareCircle.exe';
    11: Filename := 'Crowd.exe';
    12: Filename := 'InvtPend.exe';
  end;
  Case DemoSelect.ItemIndex of
    0:  Pathname := '.\Demo2-1-ChooseControl\';
    1:  Pathname := '.\Demo3-1-LiveBlock\';
    2:  Pathname := '.\Demo4-1-Trackanalyze\';
    3:  Pathname := '.\Demo5-1-NonAdaptive\';
    4:  Pathname := '.\Demo6-1-LiveThree\';
    5:  Pathname := '.\Demo7-1-Ecoli\';
    6:  Pathname := '.\Demo7-2-ThreeSys\';
    7:  Pathname := '.\Demo8-1-ArmControlReorg\';
    8:  Pathname := '.\Demo8-2-Coordination\';
    9:  Pathname := '.\Demo8-3-ArmTrackTarget\';
    10:  Pathname := '.\Demo9-1-SquareCircle\';
    11:  Pathname := '.\Demo9-2-Crowd\';
    12:  Pathname := '.\Demo9-3-InvtPend\';
    end;
end;

procedure TMainForm.ExecuteBtnClick(Sender: TObject);
var
   SEInfo: TShellExecuteInfo;
   ExecuteFile, ParamString, StartInString: string;
begin
   ExecuteFile:= Filename;
   StartInString := Pathname;
   FillChar(SEInfo, SizeOf(SEInfo), 0) ;
   SEInfo.cbSize := SizeOf(TShellExecuteInfo) ;
   with SEInfo do  // set up record parameters
   begin
     fMask := SEE_MASK_NOCLOSEPROCESS;
     Wnd := Application.Handle;
     lpFile := PChar(ExecuteFile) ;
     // lpParameters := PChar(ParamString) ;  // Application parameters
     lpDirectory := PChar(StartInString);  // Working directory.  Current
        // directory if this parameter is omitted.
     nShow := SW_SHOWNORMAL;
   end;
  {$I-}
  if FileExists(Pathname+Filename) then ShellExecuteEx(@SEInfo)
  else ShowMessage('Cannot find ' + Filename);
  {$I+}
end;

procedure TMainForm.ExitBtnClick(Sender: TObject);
begin
  Application.Terminate;
end;

end.
